Imports System.Net.Http
Imports System.Threading.Tasks
Imports GalaSoft.SimpleSerializer

Namespace Model
    Public Class DataService
        Implements IDataService

        Private Const ServiceUrl As String = "http://www.galasoft.ch/labs/json/JsonDemo.ashx"
        Private ReadOnly _client As HttpClient

        Public Sub New()
            _client = New HttpClient
        End Sub

        Public Async Function GetFriends() As Task(Of IList(Of [Friend])) Implements IDataService.GetFriends
            Dim request As HttpRequestMessage = New HttpRequestMessage(HttpMethod.Post, New Uri(ServiceUrl))

            Dim response As HttpResponseMessage = Await _client.SendAsync(request)
            Dim result As String = Await response.Content.ReadAsStringAsync

            Dim serializer As GalaSoft.SimpleSerializer.JsonSerializer = New JsonSerializer
            Dim deserialized As FacebookResult = serializer.Deserialize(Of FacebookResult)(result)

            Return deserialized.Friends
        End Function
    End Class

    <SimpleSerialize>
    Public Class FacebookResult
        <SimpleSerialize(FieldName:="data")>
        Public Property Friends As List(Of [Friend])
    End Class
End Namespace
