'
'  In App.xaml:
'  <Application.Resources>
'      <vm:ViewModelLocatorTemplate xmlns:vm="using:ProjectForTemplates.ViewModel"
'                                   x:Key="Locator" />
'  </Application.Resources>
'  
'  In the View:
'  DataContext="{Binding Source={StaticResource Locator}, Path=ViewModelName}"
'

Imports GalaSoft.MvvmLight
Imports GalaSoft.MvvmLight.Ioc
Imports GalaSoft.MvvmLight.Threading
Imports Microsoft.Practices.ServiceLocation
Imports MyFriends.Model
Imports PresenterBuddy.Helpers
Imports Windows.Foundation
Imports Windows.System.Threading

Namespace ViewModel
    ''' <summary>
    ''' This class contains static references to all the view models in the
    ''' application and provides an entry point for the bindings.
    ''' <para>
    ''' See http://www.galasoft.ch/mvvm
    ''' </para>
    ''' </summary>
    Public Class ViewModelLocator
        Shared Sub New()
            ServiceLocator.SetLocatorProvider(Function() SimpleIoc.Default)

            If ViewModelBase.IsInDesignModeStatic Then
                SimpleIoc.Default.Register(Of IDataService, Design.DesignDataService)
                SimpleIoc.Default.Register(Of INavigationService, Design.DesignNavigationService)
            Else
                SimpleIoc.Default.Register(Of IDataService, DataService)
                SimpleIoc.Default.Register(Of INavigationService)(Function() New NavigationService)
            End If

            SimpleIoc.Default.Register(Of MainViewModel)()
        End Sub

        ''' <summary>
        ''' Gets the Main property.
        ''' </summary>
        <System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Performance", "CA1822:MarkMembersAsStatic", Justification:="This non-static member is needed for data binding purposes.")>
        Public ReadOnly Property Main As MainViewModel
            Get
                Return ServiceLocator.Current.GetInstance(Of MainViewModel)()
            End Get
        End Property

        ''' <summary>
        ''' Cleans up all the resources.
        ''' </summary>
        Public Shared Sub Cleanup()
        End Sub
    End Class
End Namespace
